//Program sends commands to linear servo
//compile with: gcc commands-from-computer.c -o commands-from-computer
//run with: ./commands-from-computer
//
//Source & info: www.HomoFaciens.de/technics-computer-arduino-uno_en_navion.htm

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


#define BAUDRATE B9600 
//#define MODEMDEVICE "/dev/ttyUSB0"
#define MODEMDEVICE "/dev/ttyACM0"
#define _POSIX_SOURCE 1 /* POSIX compliant source */
#define FALSE 0
#define TRUE 1
 
FILE *file;
int fileLen;
int fd = 0;
struct termios oldtp, newtp;
//char sendcmd1[256]="\0";
 
//+++++++++++++++++++++++ Start kbhit ++++++++++++++++++++++++++++++++++
int kbhit(void) {

   struct termios term, oterm;
   int fd = 0;
   int c = 0;
   
   tcgetattr(fd, &oterm);
   memcpy(&term, &oterm, sizeof(term));
   term.c_lflag = term.c_lflag & (!ICANON);
   term.c_cc[VMIN] = 0;
   term.c_cc[VTIME] = 1;
   tcsetattr(fd, TCSANOW, &term);
   c = getchar();
   tcsetattr(fd, TCSANOW, &oterm);
   if (c != -1)
   ungetc(c, stdin);

   return ((c != -1) ? 1 : 0);

}
//------------------------ End kbhit -----------------------------------

//+++++++++++++++++++++++ Start getch ++++++++++++++++++++++++++++++++++
int getch(){
   static int ch = -1, fd = 0;
   struct termios new, old;

   fd = fileno(stdin);
   tcgetattr(fd, &old);
   new = old;
   new.c_lflag &= ~(ICANON|ECHO);
   tcsetattr(fd, TCSANOW, &new);
   ch = getchar();
   tcsetattr(fd, TCSANOW, &old);

//   printf("ch=%d ", ch);

   return ch;
}
//------------------------ End getch -----------------------------------


void  readport(void){
  int n;
	unsigned char buff;

  n = read(fd, &buff, 1);
  if(n > 0){
    printf("%d %c\n", n,buff);
  }
}

void sendport(int ValueToSend){
  int n;

  n = write(fd, &ValueToSend, 1);
  
  if (n < 0){
    fputs("write() of value failed!\n", stderr);
  }
  else{
    printf("Value %d sent successfully to Arduino.\n",ValueToSend);
  }
//  close(fd);
 
}
 
void openport(void){
  fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY |O_NDELAY );
	printf("Handle = %d\n",fd);
  if (fd <0){
   perror(MODEMDEVICE);
  }
                                                                                
  fcntl(fd,F_SETFL,0);
  tcgetattr(fd,&oldtp); /* save current serial port settings */
  // tcgetattr(fd,&newtp); /* save current serial port settings */
   bzero(&newtp, sizeof(newtp));
  // bzero(&oldtp, sizeof(oldtp));
                                                                          
   newtp.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
                                                                          
   newtp.c_iflag = IGNPAR | ICRNL;
                                                                          
   newtp.c_oflag = 0;
                                                                          
   newtp.c_lflag = ICANON;
                                                                          
   newtp.c_cc[VINTR]    = 0;     /* Ctrl-c */
   newtp.c_cc[VQUIT]    = 0;     /* Ctrl-\ */
   newtp.c_cc[VERASE]   = 0;     /* del */
   newtp.c_cc[VKILL]    = 0;     /* @ */
   //newtp.c_cc[VEOF]     = 4;     /* Ctrl-d */
   newtp.c_cc[VEOF]     = 0;     /* Ctrl-d */
   newtp.c_cc[VTIME]    = 0;     /* inter-character timer unused */
   newtp.c_cc[VMIN]     = 1;     /* blocking read until 1 character arrives */
   newtp.c_cc[VSWTC]    = 0;     /* '\0' */
   newtp.c_cc[VSTART]   = 0;     /* Ctrl-q */
   newtp.c_cc[VSTOP]    = 0;     /* Ctrl-s */
   newtp.c_cc[VSUSP]    = 0;     /* Ctrl-z */
   newtp.c_cc[VEOL]     = 0;     /* '\0' */
   newtp.c_cc[VREPRINT] = 0;     /* Ctrl-r */
   newtp.c_cc[VDISCARD] = 0;     /* Ctrl-u */
   newtp.c_cc[VWERASE]  = 0;     /* Ctrl-w */
   newtp.c_cc[VLNEXT]   = 0;     /* Ctrl-v */
   newtp.c_cc[VEOL2]    = 0;     /* '\0' */

   //     tcflush(fd, TCIFLUSH);
//	tcsetattr(fd,TCSANOW,&newtp);
} 

void main(){
  int i;
  int KeyCode[5];
  int SingleKey = 1;
  int KeyHit = 0;
  unsigned char stepWidth = 30;
  int moveDirection = 0;
  
	openport();
  sendport(110);

  while(KeyHit != 27){
    i = 0;
    SingleKey = 1;
    KeyCode[0] = 0;
    KeyCode[1] = 0;
    KeyCode[2] = 0;
    KeyCode[3] = 0;
    KeyCode[4] = 0;
    KeyHit = 0;
    while (kbhit()){
      KeyHit = getch();
      KeyCode[i] = KeyHit;
      i++;
      if(i == 5){
        i = 0;
      }
      if(i > 1){
        SingleKey = 0;
      }
      printf("KeyHit = %d\n", KeyHit);
    }
    if(SingleKey == 0){
      KeyHit = 0;
    }
    
    if(KeyCode[0] == 27 && KeyCode[1] == 91 && KeyCode[2] == 67 && KeyCode[3] == 0 && KeyCode[4] == 0){//Cursor right
      if(moveDirection == 0){
        sendport(255);
        moveDirection = 1;
      }
      sendport(stepWidth);
    }

    if(KeyCode[0] == 27 && KeyCode[1] == 91 && KeyCode[2] == 68 && KeyCode[3] == 0 && KeyCode[4] == 0){//Cursor left
      if(moveDirection == 1){
        sendport(255);
        moveDirection = 0;
      }
      sendport(stepWidth);
    }

    if(KeyCode[0] == 27 && KeyCode[1] == 79 && KeyCode[2] == 80 && KeyCode[3] == 0 && KeyCode[4] == 0){//F1
      stepWidth = 4;
      printf("StepWidth set to %d\n", stepWidth);
    }

    if(KeyCode[0] == 27 && KeyCode[1] == 79 && KeyCode[2] == 81 && KeyCode[3] == 0 && KeyCode[4] == 0){//F2
      stepWidth = 8;
      printf("StepWidth set to %d\n", stepWidth);
    }

    if(KeyCode[0] == 27 && KeyCode[1] == 79 && KeyCode[2] == 82 && KeyCode[3] == 0 && KeyCode[4] == 0){//F3
      stepWidth = 16;
      printf("StepWidth set to %d\n", stepWidth);
    }

    if(KeyCode[0] == 27 && KeyCode[1] == 79 && KeyCode[2] == 83 && KeyCode[3] == 0 && KeyCode[4] == 0){//F4
      stepWidth = 32;
      printf("StepWidth set to %d\n", stepWidth);
    }

    if(KeyCode[0] == 27 && KeyCode[1] == 91 && KeyCode[2] == 49 && KeyCode[3] == 53 && KeyCode[4] == 126){//F5
      stepWidth = 60;
      printf("StepWidth set to %d\n", stepWidth);
    }

    if(KeyCode[0] == 27 && KeyCode[1] == 91 && KeyCode[2] == 49 && KeyCode[3] == 55 && KeyCode[4] == 126){//F6
      stepWidth = 120;
      printf("StepWidth set to %d\n", stepWidth);
    }

    if(KeyCode[0] == 27 && KeyCode[1] == 91 && KeyCode[2] == 49 && KeyCode[3] == 56 && KeyCode[4] == 126){//F7
      stepWidth = 240;
      printf("StepWidth set to %d\n", stepWidth);
    }

  }

//  readport();
//	readport();
   
}
